diff -c ../zip19i/zipsplit.c ./zipsplit.c
*** ../zip19i/zipsplit.c	Tue Nov  3 21:07:59 1992
--- ./zipsplit.c	Thu Sep  9 23:28:38 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 19,25 ****
  #include <signal.h>
  
  #define DEFSIZ 36000L   /* Default split size (change in help() too) */
! #ifdef MSDOS
  #  define NL 2          /* Number of bytes written for a \n */
  #else /* !MSDOS */
  #  define NL 1          /* Number of bytes written for a \n */
--- 18,24 ----
  #include <signal.h>
  
  #define DEFSIZ 36000L   /* Default split size (change in help() too) */
! #if defined(MSDOS) || defined(__human68k__)
  #  define NL 2          /* Number of bytes written for a \n */
  #else /* !MSDOS */
  #  define NL 1          /* Number of bytes written for a \n */
***************
*** 33,41 ****
     local void license(void);
     local void help(void);
     local extent simple(ulg *, extent, ulg, ulg);
!    local int descmp(voidp *, voidp *);
     local extent greedy(ulg *, extent, ulg, ulg);
!    void main(int, char **);
  #endif /* PROTO */
  
  
--- 32,40 ----
     local void license(void);
     local void help(void);
     local extent simple(ulg *, extent, ulg, ulg);
!    local int descmp(const voidp *, const voidp *);
     local extent greedy(ulg *, extent, ulg, ulg);
!    int main(int, char **);
  #endif /* PROTO */
  
  
***************
*** 126,131 ****
--- 125,131 ----
  "  -i   make index (zipsplit.idx) and count its size against first zip file",
  "  -n   make zip files no larger than \"size\" (default = 36000)",
  "  -b   use \"path\" for the output zip files",
+ "  -p   pause between output zip files",
  "  -s   do a sequential split even if it takes more zip files",
  "  -h   show this help               -L   show software license"
    };
***************
*** 171,177 ****
  
  
  local int descmp(a, b)
! voidp *a, *b;           /* pointers to pointers to ulg's to compare */
  /* Used by qsort() in greedy() to do a descending sort. */
  {
    return **(ulg **)a < **(ulg **)b ? 1 : (**(ulg **)a > **(ulg **)b ? -1 : 0);
--- 171,177 ----
  
  
  local int descmp(a, b)
! const voidp *a, *b;           /* pointers to pointers to ulg's to compare */
  /* Used by qsort() in greedy() to do a descending sort. */
  {
    return **(ulg **)a < **(ulg **)b ? 1 : (**(ulg **)a > **(ulg **)b ? -1 : 0);
***************
*** 269,275 ****
  }
  
  
! void main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Split a zip file into several zip files less than a specified size.  See
--- 269,275 ----
  }
  
  
! int main(argc, argv)
  int argc;               /* number of tokens in command line */
  char **argv;            /* command line tokens */
  /* Split a zip file into several zip files less than a specified size.  See
***************
*** 291,301 ****
    int r;                /* temporary variable, counter */
    extent s;             /* number of bins needed */
    ulg t;                /* total of sizes, end of central directory */
    struct zlist far **w; /* malloc'ed table for zfiles linked list */
    int x;                /* if true, make an index file */
    struct zlist far *z;  /* steps through zfiles linked list */
  
- 
    /* If no args, show help */
    if (argc == 1)
    {
--- 291,304 ----
    int r;                /* temporary variable, counter */
    extent s;             /* number of bins needed */
    ulg t;                /* total of sizes, end of central directory */
+   int u;                /* flag to wait for user on output files */
    struct zlist far **w; /* malloc'ed table for zfiles linked list */
    int x;                /* if true, make an index file */
    struct zlist far *z;  /* steps through zfiles linked list */
+ #ifdef AMIGA
+   char tailchar;         /* temporary variable used in name generation below */
+ #endif
  
    /* If no args, show help */
    if (argc == 1)
    {
***************
*** 307,314 ****
  
    /* Go through args */
    signal(SIGINT, handler);
    signal(SIGTERM, handler);
!   k = h = x = d = 0;
    c = DEFSIZ;
    for (r = 1; r < argc; r++)
      if (*argv[r] == '-')
--- 310,319 ----
  
    /* Go through args */
    signal(SIGINT, handler);
+ #ifdef SIGTERM                 /* Amiga has no SIGTERM */
    signal(SIGTERM, handler);
! #endif
!   k = h = x = d = u = 0;
    c = DEFSIZ;
    for (r = 1; r < argc; r++)
      if (*argv[r] == '-')
***************
*** 335,340 ****
--- 340,347 ----
                else
                  k = 2;          /* Next non-option is size */
                break;
+             case 'p':
+               u = 1;
              case 's':
                h = 1;    /* Only try simple */
                break;
***************
*** 342,348 ****
                d = 1;
                break;
              default:
!               err(ZE_PARMS, "unknown option");
            }
        else
          err(ZE_PARMS, "zip file cannot be stdin");
--- 349,355 ----
                d = 1;
                break;
              default:
!               err(ZE_PARMS, "Use option -h for help.");
            }
        else
          err(ZE_PARMS, "zip file cannot be stdin");
***************
*** 363,369 ****
        else              /* k must be 2 */
        {
          if ((c = (ulg)atol(argv[r])) < 100)     /* 100 is smallest zip file */
!           err(ZE_PARMS, "invalid size given");
          k = 0;
        }
    if (zipfile == NULL)
--- 370,376 ----
        else              /* k must be 2 */
        {
          if ((c = (ulg)atol(argv[r])) < 100)     /* 100 is smallest zip file */
!           err(ZE_PARMS, "invalid size given. Use option -h for help.");
          k = 0;
        }
    if (zipfile == NULL)
***************
*** 386,392 ****
      if (a != NULL)
        free((voidp *)a);
      err(ZE_MEM, "was computing split");
!     return;
    }
    i = t = 0;
    for (j = 0, z = zfiles; j < zcount; j++, z = z->nxt)
--- 393,399 ----
      if (a != NULL)
        free((voidp *)a);
      err(ZE_MEM, "was computing split");
!     return 1;
    }
    i = t = 0;
    for (j = 0, z = zfiles; j < zcount; j++, z = z->nxt)
***************
*** 432,438 ****
      free((voidp *)w);  free((voidp *)a);
      free((voidp *)zipfile);
      zipfile = NULL;
!     return;
    }
  
    /* Set up path for output files */
--- 439,445 ----
      free((voidp *)w);  free((voidp *)a);
      free((voidp *)zipfile);
      zipfile = NULL;
!     exit(0);
    }
  
    /* Set up path for output files */
***************
*** 443,458 ****
    else
    {
      strcpy(path, tempath);
      if (path[0] && path[strlen(path) - 1] != '/')
        strcat(path, "/");
      name = path + strlen(path);
    }
  
    /* Write the index file */
    if (x)
    {
      strcpy(name, INDEX);
!     printf("creating %s\n", path);
      indexmade = 1;
      if ((f = fopen(path, "w")) == NULL)
      {
--- 450,478 ----
    else
    {
      strcpy(path, tempath);
+ #ifdef AMIGA
+     tailchar = path[strlen(path) - 1];  /* last character */
+     if (path[0] && (tailchar != '/') && (tailchar != ':'))
+       strcat(path, "/");
+     name = path + strlen(path);
+ #else
      if (path[0] && path[strlen(path) - 1] != '/')
        strcat(path, "/");
      name = path + strlen(path);
+ #endif /* ?AMIGA */
    }
  
    /* Write the index file */
+   if (u)
+   {
+     char m[10];
+     fputs("Insert first disk and hit return: ", stderr);
+     fgets(m, 10, stdin);
+   }
    if (x)
    {
      strcpy(name, INDEX);
!     printf("creating: %s\n", path);
      indexmade = 1;
      if ((f = fopen(path, "w")) == NULL)
      {
***************
*** 498,504 ****
--- 518,529 ----
  #ifdef VMS
    if ((q = strrchr(zipfile, ']')) != NULL)
  #else /* !VMS */
+ #  ifdef AMIGA
+   if (((q = strrchr(zipfile, '/')) != NULL)
+                        || ((q = strrchr(zipfile, ':'))) != NULL)
+ #  else /* !AMIGA */
    if ((q = strrchr(zipfile, '/')) != NULL)
+ #  endif /* ?AMIGA */
  #endif /* ?VMS */
      q++;
    else
***************
*** 522,529 ****
    zipfile = NULL;
    for (j = 0; j < s; j++)
    {
      sprintf(name, template, j + 1);
!     printf("creating %s\n", path);
      zipsmade = j + 1;
      if ((f = fopen(path, FOPW)) == NULL)
      {
--- 547,560 ----
    zipfile = NULL;
    for (j = 0; j < s; j++)
    {
+     if (u && j)
+     {
+       char m[10];
+       fputs("Insert next disk and hit return: ", stderr);
+       fgets(m, 10, stdin);
+     }
      sprintf(name, template, j + 1);
!     printf("creating: %s\n", path);
      zipsmade = j + 1;
      if ((f = fopen(path, FOPW)) == NULL)
      {
***************
*** 579,582 ****
--- 610,614 ----
  
    /* Done! */
    exit(0);
+   return 0; /* avoid warning */
  }
diff -c ../zip19i/zipup.c ./zipup.c
*** ../zip19i/zipup.c	Tue Nov  3 21:07:59 1992
--- ./zipup.c	Fri Sep 10 05:34:50 1993
***************
*** 1,11 ****
  /*
  
!  Copyright (C) 1990-1992 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included
!  unmodified, that it is not sold for profit, and that this copyright notice
!  is retained.
  
  */
  
--- 1,10 ----
  /*
  
!  Copyright (C) 1990-1993 Mark Adler, Richard B. Wales, Jean-loup Gailly,
   Kai Uwe Rommel and Igor Mandrichenko.
   Permission is granted to any individual or institution to use, copy, or
!  redistribute this software so long as all of the original files are included,
!  that it is not sold for profit, and that this copyright notice is retained.
  
  */
  
***************
*** 30,71 ****
  #  endif
  #endif
  
- /* The following OS codes are defined in pkzip appnote.txt */
- #ifdef AMIGA
- #  define OS_CODE  0x100
- #endif
- #ifdef VMS
- #  define OS_CODE  0x200
- #endif
- /* unix    3 */
- /* vms/cms 4 */
- #ifdef ATARI_ST
- #  define OS_CODE  0x500
- #endif
- #ifdef OS2
- #  define OS_CODE  0x600
- #endif
- #ifdef MACOS
- #  define OS_CODE  0x700
- #endif
- /* z system 8 */
- /* cp/m     9 */
- #ifdef TOPS20
- #  define OS_CODE  0xa00
- #endif
- #ifdef WIN32
- #  define OS_CODE  0xb00
- #endif
- /* qdos 12 */
- 
- #if defined(MSDOS) && !defined(OS_CODE)
- #  define OS_CODE  0x000
- #endif
- #ifndef OS_CODE
- #  define OS_CODE  0x300  /* assume Unix */
- #endif
  
- 
  /* Use the raw functions for MSDOS and Unix to save on buffer space.
     They're not used for VMS since it doesn't work (raw is weird on VMS).
     (This sort of stuff belongs in fileio.c, but oh well.) */
--- 29,35 ----
***************
*** 83,111 ****
     int vms_close OF((ftype));
     int vms_error OF((ftype));
  #else /* !VMS */
! #  if defined(MSDOS) && !defined(ATARI_ST)
  #    include <io.h>
  #    include <fcntl.h>
  #    define fhow (O_RDONLY|O_BINARY)
  #  else /* !MSDOS */
  #    if defined(SYSV) || defined(__386BSD__)
! #      include <fcntl.h>
! #    else
!        int open OF((char *, int));
!        int read OF((int, char *, int));
!        int close OF((int));
!        int lseek OF((int, long, int));
  #    endif
  #    ifdef TOPS20
  #      define O_RDONLY (0)
! #      define O_UNCONVERTED	(0400) /* Forced NO conversion requested */
  #      define fhow (O_RDONLY | O_UNCONVERTED)
  #    else
! #      define fhow 0
  #    endif
  #  endif /* ?MSDOS */
     typedef int ftype;
! #  define fbad (-1)
  #  define zopen(n,p) open(n,p)
  #  define zread(f,b,n) read(f,b,n)
  #  define zclose(f) close(f)
--- 47,81 ----
     int vms_close OF((ftype));
     int vms_error OF((ftype));
  #else /* !VMS */
! #  if (defined(MSDOS) && !defined(ATARI_ST)) || defined(__human68k__)
  #    include <io.h>
  #    include <fcntl.h>
  #    define fhow (O_RDONLY|O_BINARY)
  #  else /* !MSDOS */
  #    if defined(SYSV) || defined(__386BSD__)
! #      include <fcntl.h>  /* open(), read(), close(), lseek() */
  #    endif
  #    ifdef TOPS20
  #      define O_RDONLY (0)
! #      define O_UNCONVERTED     (0400) /* Forced NO conversion requested */
  #      define fhow (O_RDONLY | O_UNCONVERTED)
  #    else
! #      ifdef AMIGA
! #        include <fcntl.h>
! #        define fhow (O_RDONLY | O_RAW)
! #        define fbad (-1)
! #        ifdef AZTEC_C
! #          define O_RAW 0
! #        endif
! #      else
! #        define fhow 0
! #      endif
  #    endif
  #  endif /* ?MSDOS */
     typedef int ftype;
! #  ifndef fbad
! #    define fbad (-1)
! #  endif
  #  define zopen(n,p) open(n,p)
  #  define zread(f,b,n) read(f,b,n)
  #  define zclose(f) close(f)
***************
*** 113,126 ****
  #  define zstdin 0
  #endif /* ?VMS */
  
  #if defined(MMAP) || defined(BIG_MEM)
    extern uch * window;          /* Used to read all input file at once */
-   extern ulg window_size;       /* size of said window */
  #endif
  
  /* Local data */
  
- #ifndef UTIL
    local ulg crc;       /* crc on uncompressed file data */
    local ftype ifile;   /* file to compress */
    local long remain;
--- 83,97 ----
  #  define zstdin 0
  #endif /* ?VMS */
  
+ #ifndef UTIL
+ 
  #if defined(MMAP) || defined(BIG_MEM)
    extern uch * window;          /* Used to read all input file at once */
  #endif
+ extern ulg window_size;         /* size of said window */
  
  /* Local data */
  
    local ulg crc;       /* crc on uncompressed file data */
    local ftype ifile;   /* file to compress */
    local long remain;
***************
*** 147,157 ****
  {
    ulg n;                /* holds local header offset */
  
!   if (fseek(x, z->off, SEEK_SET))
!     return ferror(x) ? ZE_READ : ZE_EOF;
!   z->off = tempzn;
!   n = 4 + LOCHEAD + (long)z->nam + (long)z->ext + z->siz;
!   /* copy the extended local header if there is one */
    if (z->lflg & 8) n += 16;
    tempzn += n;
    return fcopy(x, y, n);
--- 118,145 ----
  {
    ulg n;                /* holds local header offset */
  
!   Trace((stderr, "zipcopy %s\n", z->zname));
!   n = 4 + LOCHEAD + (long)z->nam + (long)z->ext;
! 
!   if (fix > 1) {
!     /* do not trust the old compressed size */
!     if (putlocal(z, y) != ZE_OK)
!       return ZE_TEMP;
! 
!     if (fseek(x, z->off + n, SEEK_SET)) /* seek to compressed data */
!       return ferror(x) ? ZE_READ : ZE_EOF;
! 
!     z->off = tempzn;
!     tempzn += n;
!     n = z->siz;
!   } else {
!     if (fseek(x, z->off, SEEK_SET))     /* seek to local header */
!       return ferror(x) ? ZE_READ : ZE_EOF;
! 
!     z->off = tempzn;
!     n += z->siz;
!   }
!   /* copy the compressed data and the extended local header if there is one */
    if (z->lflg & 8) n += 16;
    tempzn += n;
    return fcopy(x, y, n);
***************
*** 161,167 ****
  #ifndef UTIL
  
  int percent(n, m)
! long n, m;               /* n is the original size, m is the new size */
  /* Return the percentage compression from n to m using only integer
     operations */
  {
--- 149,156 ----
  #ifndef UTIL
  
  int percent(n, m)
! ulg n;
! ulg m;               /* n is the original size, m is the new size */
  /* Return the percentage compression from n to m using only integer
     operations */
  {
***************
*** 170,176 ****
      n += 0x80;  n >>= 8;
      m += 0x80;  m >>= 8;
    }
!   return n ? (int)(1 + (200 * (n - m)/n)) / 2 : 0;
  }
  
  local int suffixes(a, s)
--- 159,165 ----
      n += 0x80;  n >>= 8;
      m += 0x80;  m >>= 8;
    }
!   return n > m ? (int)(1 + (200 * (n - m)/n)) / 2 : 0;
  }
  
  local int suffixes(a, s)
***************
*** 228,234 ****
    int l = 0;            /* true if this file is a symbolic link */
    int m;                /* method for this entry */
    ulg o, p;             /* offsets in zip file */
!   long q = -2L;         /* size returned by filetime */
    int r;                /* temporary variable */
    ulg s = 0L;           /* size of compressed data */
    int isdir;            /* set for a directory name */
--- 217,223 ----
    int l = 0;            /* true if this file is a symbolic link */
    int m;                /* method for this entry */
    ulg o, p;             /* offsets in zip file */
!   long q = -3L;         /* size returned by filetime */
    int r;                /* temporary variable */
    ulg s = 0L;           /* size of compressed data */
    int isdir;            /* set for a directory name */
***************
*** 238,248 ****
    isdir = z->zname[z->nam-1] == '/';
    z->att = (ush)UNKNOWN; /* will be changed later */
  
!   if ((z->tim = filetime(z->name, &a, &q)) == 0 || q < -1L)
      return ZE_OPEN;
!   /* q is set to -1 if the input file is a device */
! 
    remain = -1L; /* changed only for BIG_MEM */
  
    /* Select method based on the suffix and the global method */
    m = special != NULL && suffixes(z->name, special) ? STORE : method;
--- 227,241 ----
    isdir = z->zname[z->nam-1] == '/';
    z->att = (ush)UNKNOWN; /* will be changed later */
  
!   if ((z->tim = filetime(z->name, &a, &q)) == 0 || q < -2L)
      return ZE_OPEN;
!   /* q is set to -1 if the input file is a device, -2 for a volume label */
!   if (q == -2L) {
!      isdir = 1;
!      q = 0;
!   }
    remain = -1L; /* changed only for BIG_MEM */
+   window_size = 0L;
  
    /* Select method based on the suffix and the global method */
    m = special != NULL && suffixes(z->name, special) ? STORE : method;
***************
*** 251,257 ****
    if (strcmp(z->name, "-") == 0)
    {
      ifile = (ftype)zstdin;
! #ifdef MSDOS
      setmode(zstdin, O_BINARY);
  #endif
    }
--- 244,250 ----
    if (strcmp(z->name, "-") == 0)
    {
      ifile = (ftype)zstdin;
! #if defined(MSDOS) || defined(__human68k__)
      setmode(zstdin, O_BINARY);
  #endif
    }
***************
*** 264,269 ****
--- 257,263 ----
      else if (isdir) { /* directory */
        ifile = fbad;
        m = STORE;
+       q = 0;
      }
      else if ((ifile = zopen(z->name, fhow)) == fbad)
        return ZE_OPEN;
***************
*** 272,282 ****
      /* Map ordinary files but not devices. This code should go in fileio.c */
      if (q > 0 && !translate_eol) {
        if (window != NULL)
! 	free(window);  /* window can't be a mapped file here */
        window_size = q + MIN_LOOKAHEAD;
        window = (uch*)mmap(0, window_size, PROT_READ, MAP_SHARED, ifile, 0);
        if (window == (uch*)(-1)) {
! 	window = NULL;
          return ZE_OPEN;
        }
        /* If we can't touch the page beyond the end of file, remap
--- 266,276 ----
      /* Map ordinary files but not devices. This code should go in fileio.c */
      if (q > 0 && !translate_eol) {
        if (window != NULL)
!         free(window);  /* window can't be a mapped file here */
        window_size = q + MIN_LOOKAHEAD;
        window = (uch*)mmap(0, window_size, PROT_READ, MAP_SHARED, ifile, 0);
        if (window == (uch*)(-1)) {
!         window = NULL;
          return ZE_OPEN;
        }
        /* If we can't touch the page beyond the end of file, remap
***************
*** 290,297 ****
           * we would have enough space in the first page (assuming a page
           * size of at least 512 bytes)
           */
! 	fprintf(mesg, " cannot extend mmap on %s", z->name);
! 	window = NULL;
          return ZE_OPEN;
        }
        remain = q;
--- 284,291 ----
           * we would have enough space in the first page (assuming a page
           * size of at least 512 bytes)
           */
!         fprintf(mesg, " cannot extend mmap on %s", z->name);
!         window = NULL;
          return ZE_OPEN;
        }
        remain = q;
***************
*** 302,315 ****
      if (q > 0 && !translate_eol) {
        window_size = q + MIN_LOOKAHEAD;
        window = window ? (uch*) realloc(window, (unsigned)window_size)
! 		      : (uch*) malloc((unsigned)window_size);
        /* Just use normal code if big malloc or realloc fails: */
        if (window != NULL) {
! 	remain = zread(ifile, (char*)window, q+1);
! 	if (remain != q) {
! 	  fprintf(mesg, " q=%ld, remain=%ld ", q, remain);
! 	  error("can't read whole file at once");
! 	}
        }
      }
  # endif /* BIG_MEM */
--- 296,311 ----
      if (q > 0 && !translate_eol) {
        window_size = q + MIN_LOOKAHEAD;
        window = window ? (uch*) realloc(window, (unsigned)window_size)
!                       : (uch*) malloc((unsigned)window_size);
        /* Just use normal code if big malloc or realloc fails: */
        if (window != NULL) {
!         remain = zread(ifile, (char*)window, q+1);
!         if (remain != q) {
!           fprintf(mesg, " q=%ld, remain=%ld ", q, remain);
!           error("can't read whole file at once");
!         }
!       } else {
!         window_size = 0L;
        }
      }
  # endif /* BIG_MEM */
***************
*** 336,351 ****
     */
  
    /* (Assume ext, cext, com, and zname already filled in.) */
! #ifdef OS2
!   z->vem = z->dosflag ? 20 :            /* Made under MSDOS by PKZIP 2.0 */
!   /* For a FAT file system, we must cheat and pretend that the file
     * was not made on OS2 but under DOS. unzip is confused otherwise.
     */
  #else
    z->vem = dosify ? 20 : OS_CODE + REVISION;
  #endif
  
!   z->ver = 20;                          /* Need PKUNZIP 2.0 */
    z->crc = 0;  /* to be updated later */
    /* Assume first that we will need an extended local header: */
    z->flg = 8;  /* to be updated later */
--- 332,348 ----
     */
  
    /* (Assume ext, cext, com, and zname already filled in.) */
! #if defined(OS2) || defined(WIN32)
!   z->vem = z->dosflag ? 20       /* Made under MSDOS by PKZIP 2.0 */
!          : OS_CODE + REVISION;
!   /* For a FAT file system, we cheat and pretend that the file
     * was not made on OS2 but under DOS. unzip is confused otherwise.
     */
  #else
    z->vem = dosify ? 20 : OS_CODE + REVISION;
  #endif
  
!   z->ver = m == STORE ? 10 : 20;     /* Need PKUNZIP 2.0 except for store */
    z->crc = 0;  /* to be updated later */
    /* Assume first that we will need an extended local header: */
    z->flg = 8;  /* to be updated later */
***************
*** 380,386 ****
      tempzn += RAND_HEAD_LEN;
    }
  #endif
!   o = ftell(y); /* for debugging only */
  
    /* Write stored or deflated file to zip file */
    isize = 0L;
--- 377,387 ----
      tempzn += RAND_HEAD_LEN;
    }
  #endif
!   if (ferror(y))
!     err(ZE_WRITE, "unexpected error on zip file");
!   o = ftell(y); /* for debugging only, ftell can fail on pipes */
!   if (ferror(y))
!     clearerr(y); 
  
    /* Write stored or deflated file to zip file */
    isize = 0L;
***************
*** 399,413 ****
         return ZE_MEM;
  
      if (!isdir) /* no read for directories */
!     while ((k = l ? rdsymlnk(z->name, b, CBSZ) : zread(ifile, b, CBSZ)) > 0)
      {
-       isize += k;
-       crc = updcrc(b, k);
        if (zfwrite(b, 1, k, y) != k)
        {
          free((voidp *)b);
          return ZE_TEMP;
        }
  #ifdef MINIX
        if (l)
          q = k;
--- 400,413 ----
         return ZE_MEM;
  
      if (!isdir) /* no read for directories */
!     while ((k = l ? rdsymlnk(z->name, b, CBSZ) : file_read(b, CBSZ)) > 0)
      {
        if (zfwrite(b, 1, k, y) != k)
        {
          free((voidp *)b);
          return ZE_TEMP;
        }
+       if (verbose) putc('.', stderr);
  #ifdef MINIX
        if (l)
          q = k;
***************
*** 432,445 ****
    tempzn += s;
    p = tempzn; /* save for future fseek() */
  
! #ifndef VMS
!   /* Check input size (but not in VMS--variable record lengths mess it up) */
    if (q >= 0 && isize != (ulg)q && !translate_eol)
    {
!     fprintf(mesg, " i=%ld, q=%ld ", isize, q);
!     error("incorrect input size");
    }
! #endif /* !VMS */
  
    /* Try to rewrite the local header with correct information */
    z->crc = crc;
--- 432,447 ----
    tempzn += s;
    p = tempzn; /* save for future fseek() */
  
! #if !defined(MSDOS) && !defined(VMS)
!   /* Check input size (but not in VMS -- variable record lengths mess it up)
!    * and not on MSDOS -- diet in TSR mode reports an incorrect file size)
!    */
    if (q >= 0 && isize != (ulg)q && !translate_eol)
    {
!     Trace((mesg, " i=%ld, q=%ld ", isize, q));
!     warn(" file size changed while zipping ", z->name);
    }
! #endif
  
    /* Try to rewrite the local header with correct information */
    z->crc = crc;
***************
*** 467,472 ****
--- 469,475 ----
      }
  #endif
      z->how = m;
+     z->ver = m == STORE ? 10 : 20;     /* Need PKUNZIP 2.0 except for store */
      if ((z->flg & 1) == 0)
        z->flg &= ~8; /* clear the extended local header flag */
      z->lflg = z->flg;
***************
*** 482,487 ****
--- 485,496 ----
        tempzn += 16L;
      }
    }
+   /* Free the local extra field which is no longer needed */
+   if (z->ext) {
+     if (z->extra != z->cextra)
+       free((voidp *)(z->extra));
+     z->ext = 0;
+   }
  
    /* Display statistics */
    if (noisy)
***************
*** 526,539 ****
  #endif
    if (translate_eol == 0) {
      len = zread(ifile, buf, size);
!     if (len == (unsigned)EOF || len == 0) return len;
  
    } else if (translate_eol == 1) {
      /* Transform LF to CR LF */
      size >>= 1;
      b = buf+size;
      size = len = zread(ifile, b, size);
!     if (len == (unsigned)EOF || len == 0) return len;
      do {
         if ((*buf++ = *b++) == '\n') *(buf-1) = '\r', *buf++ = '\n', len++;
      } while (--size != 0);
--- 535,548 ----
  #endif
    if (translate_eol == 0) {
      len = zread(ifile, buf, size);
!     if (len == (unsigned)EOF || len == 0) return (int)len;
  
    } else if (translate_eol == 1) {
      /* Transform LF to CR LF */
      size >>= 1;
      b = buf+size;
      size = len = zread(ifile, b, size);
!     if (len == (unsigned)EOF || len == 0) return (int)len;
      do {
         if ((*buf++ = *b++) == '\n') *(buf-1) = '\r', *buf++ = '\n', len++;
      } while (--size != 0);
***************
*** 543,549 ****
      /* Transform CR LF to LF and suppress final ^Z */
      b = buf;
      size = len = zread(ifile, buf, size-1);
!     if (len == (unsigned)EOF || len == 0) return len;
      buf[len] = '\n'; /* I should check if next char is really a \n */
      do {
         if ((*buf++ = *b++) == '\r' && *b == '\n') buf--, len--;
--- 552,558 ----
      /* Transform CR LF to LF and suppress final ^Z */
      b = buf;
      size = len = zread(ifile, buf, size-1);
!     if (len == (unsigned)EOF || len == 0) return (int)len;
      buf[len] = '\n'; /* I should check if next char is really a \n */
      do {
         if ((*buf++ = *b++) == '\r' && *b == '\n') buf--, len--;
***************
*** 557,562 ****
    }
    crc = updcrc(buf, len);
    isize += (ulg)len;
!   return len;
  }
  #endif /* !UTIL */
--- 566,571 ----
    }
    crc = updcrc(buf, len);
    isize += (ulg)len;
!   return (int)len;
  }
  #endif /* !UTIL */
